/**
 * @file   uni.c
 * @author David Bremner <bremner@unb.ca>
 * @date   Sat Jun 15 17:38:32 2002
 * 
 * @brief  uniform random number generator, courtesy of Luc Devroye.
 * 
 * 
 */


#include <math.h>


static long s1 = 55555;
static long s2 = 99999;


void set_seed(v1,v2)
     long v1,v2;
{
  s1=v1;
  s2=v2;
}

void get_seed(p1,p2)
     long *p1,*p2;
{
  *p1=s1;
  *p2=s2;
}

double uni()
{
static double factor = 1.0/2147483399.0;
register long k,z;
	k= s1 /53668;
	s1 =40014*(s1%53668)-k*12211;
	if (s1 < 0) s1 += 2147483563;
	k=s2/52774;
	s2=40692*(s2%52774)-k*3791;
	if (s2 < 0) s2 += 2147483399;

	/*
	z = abs(s1 ^ s2);
	*/
	z= (s1 - 2147483563) + s2;
	if (z < 1) z += 2147483562;
	
	return(((double)(z))*factor);
}
