#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "combinat.h"
#include "error_message.h"
#include "scan.h"

static void usage(char *name){
  printf("usage: %s [-e] [-o outfile ] -r rank  -n elements\n",name);
  exit(1);
}

int main(int argc, char **argv){
  array_index_t n=-1,r=-1;
  int i;
  int c;  
  int tok;
  natural_t *pi;
  int array_index_t=0;

  while((c=getopt(argc,argv,"eo:r:n:"))!=-1){
    switch(c){
    case 'r':
      r=atoi(optarg);
      break;
    case 'n':
      n=atoi(optarg);
      break;
    case 'o':
      freopen(optarg,"w",stdout);
      err_assert(stdout);
      break;
    case 'e':
      array_index_t=1;
      break;

    default:
      usage(argv[0]);
      exit(1);
    }
  }
  
  if (n==-1 || r==-1)
    err_fatal(HERE,"you must specify dimension and number of elements");


  pi=calloc(r,sizeof(natural_t));

  i=0;
  while ((tok=scanlex())>0){
    if (i>=r || tok==SCAN_EOL){
      i=0;
      printf("%d\n", kset_cindex(n,r,pi)+array_index_t);
    } else {
      switch(tok){
      case SCAN_INT:
	pi[i++]=scanint;
	break;
      default:
	err_fatal(HERE,"bad token %d %s",tok,scantext);
      }
    }
  }
}
