#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "combinat.h"
#include "error_message.h"
#include "scan.h"

static void usage(char *name){
  printf("usage: %s [-e] [-o outfile ] -r dim  -n elements\n",name);
  exit(1);
}

int main(int argc, char **argv){
  array_index_t n=-1,r=-1,b=-1;
  int c;  
  int tok;
  natural_t *pi;
  int array_index_t=0;



  while((c=getopt(argc,argv,"eo:r:n:b:"))!=-1){
    switch(c){
    case 'e':
      array_index_t=-1;
      break;
    case 'r':
      r=atoi(optarg);
      break;
    case 'b':
      b=atoi(optarg);
      break;
    case 'n':
      n=atoi(optarg);
      break;
    case 'o':
      freopen(optarg,"w",stdout);
      err_assert(stdout);
      break;
    default:
      usage(argv[0]);
      exit(1);
    }
  }
  
  if (n==-1 || r==-1)
    err_fatal(HERE,"you must specify dimension and number of elements");


  
  pi=calloc(r,sizeof(natural_t));

  if (b!=-1){
    output_bindex(n,r,b+array_index_t,pi);
  } else {
    while ((tok=scanlex())>0){
      switch(tok){
      case SCAN_MINUS:
	printf(" -");
	break;
      case SCAN_INT:
	output_kset(n,r,scanint+array_index_t,pi);
	break;
      case SCAN_EOL:
	printf("\n");
	break;
      default:
	err_fatal(HERE,"bad token %d %s",tok,scantext);
      }
    }
  }
  return 0;
}
